<?php
/*
Plugin Name: ぱっ！とフォン
Plugin URI: http://with-planning.jp/wordpress_plugins
Description: ～ぱっ！とシリーズ～ ワンボタンでクリッカブルな電話番号リンクを挿入するプラグインです
Author: with-planning
Version: 1.0
Author URI: http://with-planning.jp/
 */

// HTMLエディタにボタンを追加
function addPaPhoneTag(){
    ?>s
    <script type="text/javascript">
        QTags.addButton('addPaPhone', '電話番号を追加', '[電話番号 tel=""][/電話番号]');
    </script>
    <?php
}
add_action('admin_print_footer_scripts','addPaPhoneTag');


// 動画の埋め込み
function paphoneEmbed($attributes, $content = null) {
    
    // ショートコードの属性を展開
    extract(shortcode_atts(array('tel' => ''), $attributes));

    if(empty($tel)){
        return '<span style="font-weight:900; color:red;">電話番号が設定されていません。</span>';
    }else{
        // 電話番号に-が入っていた場合削除する。
        $tel = str_replace('-', '', $tel);

        if(empty($content)){
            return '<a class="paphone-tel" href="tel:' . $tel . '">' . $tel . '</a>';
        }else{
            return '<a class="paphone-wapper" href="tel:' . $tel . '">' . $content . '</a>';
        }
    }
}
add_shortcode('電話番号', 'paphoneEmbed');
add_shortcode('tel', 'paphoneEmbed');

// TinyMCE Add Button
class AddPaPhoneMceButton {

    function AddMceButton() {
        add_action('init', array(&$this, 'addbuttons'));
    }
    function sink_hooks(){
        add_filter('mce_plugins', array(&$this, 'mce_plugins'));
    }

    function addbuttons() {
        // 編集権限の確認
        if ( ! current_user_can('edit_posts') && ! current_user_can('edit_pages') ){
            return;
        }
        
        // ビジュアルエディタの時だけ追加
        if ( get_user_option('rich_editing') == 'true') {
            add_filter("mce_external_plugins", array(&$this, 'mce_external_plugins'));
            // フィルターで何行目にボタンを表示するか決定している
            // 1行目は「mce_buttons」2行目以降は「mce_buttons_行数」となる。なお、最大4行目まで。
            $colPosition = get_option('paPhoneColumnPosition');
            switch($colPosition){
                case 2:
                    add_filter('mce_buttons_2', array(&$this, 'mce_buttons'));
                    break;
                case 3:
                    add_filter('mce_buttons_3', array(&$this, 'mce_buttons'));
                    break;
                case 4:
                    add_filter('mce_buttons_4', array(&$this, 'mce_buttons'));
                    break;
                case 1:
                default:
                    add_filter('mce_buttons', array(&$this, 'mce_buttons'));
                    break;
            }
        }
    }

    function mce_buttons($buttons) {
        array_push($buttons, " ", "AddPaPhone");

        return $buttons;
    }

    // TinyMCE プラグインファイルを読み込む: editor_plugin.js
    function mce_external_plugins($plugin_array) {
        //プラグイン関数名＝ファイルの位置
        $plugin_array['AddPaPhoneButton'] = plugins_url( '', __FILE__ ) . '/js/AddButton.js';
        return $plugin_array;
    }

}
$paPhoneEditButton = new AddPaPhoneMceButton();
add_action('init',array(&$paPhoneEditButton, 'AddMceButton'), 9);

// 設定画面
function paPhoneConfigPage(){
?>
    <div class="wrap">
        <h2>ぱっ！とフォン</h2>
        <form method="post" action="options.php">
            <?php wp_nonce_field('update-options'); ?>
            <table class="form-table">
                <tr valign="top">
                    <th scope="row">ボタンの表示位置<br /><span style="font-weight:normal;font-size:small">（ボタンがエディターに並ぶ際の表示場所）</span></th>
                    <td>
                        <?php $colPos = get_option('paPhoneColumnPosition') === false ? 1 : get_option('paPhoneColumnPosition'); ?>
                        1行目:<input type="radio" name="paPhoneColumnPosition" value="1"<?php checked($colPos, 1) ?> /><br />
                        2行目:<input type="radio" name="paPhoneColumnPosition" value="2"<?php checked($colPos, 2) ?> /><br />
                        3行目:<input type="radio" name="paPhoneColumnPosition" value="3"<?php checked($colPos, 3) ?> /><br />
                        4行目:<input type="radio" name="paPhoneColumnPosition" value="4"<?php checked($colPos, 4) ?> /><br />
                    </td>
                </tr>
            </table>
            <input type="hidden" name="action" value="update" />
            <input type="hidden" name="page_options" value="paPhoneColumnPosition" />
            <p class="submit">
                <input type="submit" class="button-primary" value="<?php _e('Save Changes') ?>" />
            </p>
        </form>
    </div>
<?php
}
add_action('admin_menu', 'admin_menu_paphone');
function admin_menu_paphone () {
    add_options_page('ぱっ！とフォン', 'ぱっ！とフォン', 'manage_options', __FILE__, 'paPhoneConfigPage');
}

// プラグインアンインストール時に設定を削除
if(function_exists("register_uninstall_hook")){
    register_uninstall_hook(__FILE__, 'uninstall_paphone');
}
function uninstall_paphone(){
    delete_option('paPhoneColumnPosition');
}
?>